'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SkinnableComponent2 = require('./SkinnableComponent');

var _SkinnableComponent3 = _interopRequireDefault(_SkinnableComponent2);

var _events = require('../utils/events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Bubble = (_temp2 = _class = function (_SkinnableComponent) {
  _inherits(Bubble, _SkinnableComponent);

  function Bubble() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Bubble);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Bubble.__proto__ || Object.getPrototypeOf(Bubble)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      position: null
    }, _this._hasEventListeners = false, _this._handleScrollEventListener = function (action) {
      var rootNode = _this._getRootSkinPart();
      var scrollableNode = _this._getFirstScrollableParent(rootNode);
      if (scrollableNode) {
        if (action === 'add') {
          scrollableNode.addEventListener('scroll', _this._updatePosition);
        } else if (action === 'remove') {
          scrollableNode.removeEventListener('scroll', _this._updatePosition);
        }
      }
    }, _this._getFirstScrollableParent = function (node) {
      if (node == null) return null;
      if (node === _this._getRootSkinPart() || node.scrollHeight <= node.clientHeight) {
        return _this._getFirstScrollableParent(node.parentNode);
      } else {
        return node;
      }
    }, _this._updatePosition = function () {
      var isOpeningUpward = _this.props.isOpeningUpward;

      var rootNode = _this._getRootSkinPart();
      var parentNode = rootNode.parentNode;
      var parentNodeParams = parentNode.getBoundingClientRect();

      var positionY = void 0;
      if (isOpeningUpward) {
        positionY = window.innerHeight - parentNodeParams.top + 20;
      } else {
        positionY = parentNodeParams.bottom + 20;
      }

      var position = {
        width: parentNodeParams.width,
        positionX: parentNodeParams.left,
        positionY: positionY
      };
      _this.setState({ position: position });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Bubble, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        if (_this2.props.isFloating) _this2._updatePosition();
      }, 0);
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps) {
      var isFloating = this.props.isFloating;
      // Add listeners when the bubble

      if (isFloating && !nextProps.isHidden && !this._hasEventListeners) {
        this._handleScrollEventListener('add');
        _events2.default.addEventsToDocument(this._getDocumentEvents());
        window.addEventListener('resize', this._updatePosition);
        this._hasEventListeners = true;
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var isHidden = this.props.isHidden;

      var didVisibilityChange = isHidden !== prevProps.isHidden;
      var wasBubbleHidden = !prevProps.isHidden && isHidden;

      if (wasBubbleHidden) this._removeAllEventListeners();
      if (didVisibilityChange) this._updatePosition();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this._hasEventListeners) this._removeAllEventListeners();
    }
  }, {
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      return Object.assign({}, _get(Bubble.prototype.__proto__ || Object.getPrototypeOf(Bubble.prototype), 'prepareSkinProps', this).call(this, props), {
        position: this.state.position
      });
    }

    // =========== PRIVATE HELPERS ==============

  }, {
    key: '_removeAllEventListeners',
    value: function _removeAllEventListeners() {
      if (this._hasEventListeners) {
        _events2.default.removeEventsFromDocument(this._getDocumentEvents());
        this._handleScrollEventListener('remove');
        window.removeEventListener('resize', this._updatePosition);
        this._hasEventListeners = false;
      }
    }
  }, {
    key: '_getRootSkinPart',
    value: function _getRootSkinPart() {
      return this.skinParts[Bubble.SKIN_PARTS.ROOT];
    }
  }, {
    key: '_getDocumentEvents',
    value: function _getDocumentEvents() {
      return {
        resize: this._updatePosition,
        scroll: this._updatePosition
      };
    }
  }]);

  return Bubble;
}(_SkinnableComponent3.default), _class.SKIN_PARTS = {
  ROOT: 'root',
  BUBBLE: 'bubble'
}, _class.propTypes = Object.assign({}, _SkinnableComponent3.default.propTypes, {
  isOpeningUpward: _propTypes2.default.bool,
  isTransparent: _propTypes2.default.bool,
  isFloating: _propTypes2.default.bool,
  isHidden: _propTypes2.default.bool
}), _class.defaultProps = {
  isOpeningUpward: false,
  isTransparent: true,
  isFloating: false,
  isHidden: false
}, _temp2);
exports.default = Bubble;
//# sourceMappingURL=Bubble.js.map