'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _flow2 = require('lodash/flow');

var _flow3 = _interopRequireDefault(_flow2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _FormField2 = require('./FormField');

var _FormField3 = _interopRequireDefault(_FormField2);

var _props2 = require('../utils/props');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NumericInput = (_temp2 = _class = function (_FormField) {
  _inherits(NumericInput, _FormField);

  function NumericInput() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, NumericInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = NumericInput.__proto__ || Object.getPrototypeOf(NumericInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      caretPosition: 0, // Current caret position
      separatorsCount: 0, // Number of comma separators used for calculating caret position after separators are injected
      error: null, // Inner (Component) state error
      // e.g. if value > maxValue set error message
      oldValue: null // Last recorded value before input change
    }, _this.onChange = function (event) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled;

      if (disabled) return;
      var processedValue = _this._processValue(event.target.value, event.target.selectionStart, {});
      if (onChange) onChange(processedValue, event);
    }, _this.focus = function () {
      return _this.skinParts[NumericInput.SKIN_PARTS.INPUT].focus();
    }, _this.blur = function () {
      return _this.skinParts[NumericInput.SKIN_PARTS.INPUT].blur();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(NumericInput, [{
    key: 'componentDidMount',


    // ========= COMPONENT LIFE CYCLE =========

    value: function componentDidMount() {
      // Set last input caret position on updates
      var input = this.skinParts[NumericInput.SKIN_PARTS.INPUT];
      this.setState({ caretPosition: input.selectionStart });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var input = this.skinParts[NumericInput.SKIN_PARTS.INPUT];
      if (input !== document.activeElement) return;

      // caret position calculation after separators injection
      var caretPosition = void 0;
      // prevent unnecessary changes on re-rendering
      if (this.state.oldValue != prevState.oldValue || this.state.caretPosition != prevState.caretPosition) {
        if (this.state.separatorsCount != prevState.separatorsCount && this.state.separatorsCount - prevState.separatorsCount <= 1 && this.state.separatorsCount - prevState.separatorsCount >= -1) {
          caretPosition = this.state.caretPosition + (this.state.separatorsCount - prevState.separatorsCount);
        } else {
          caretPosition = this.state.caretPosition;
        }
        caretPosition = caretPosition >= 0 ? caretPosition : 0;
        input.selectionEnd = caretPosition;
        input.selectionStart = caretPosition;
      }
    }
  }, {
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      return Object.assign({}, _get(NumericInput.prototype.__proto__ || Object.getPrototypeOf(NumericInput.prototype), 'prepareSkinProps', this).call(this, props), {
        onChange: this.onChange,
        error: this.props.error || this.state.error
      });
    }
  }, {
    key: '_processValue',
    value: function _processValue(value, position) {
      return (0, _flow3.default)([this._enforceNumericValue, this._parseToParts, this._enforceMaxLengths, this._separate]).call(this, value, position);
    }
  }, {
    key: '_enforceNumericValue',
    value: function _enforceNumericValue(value, position) {
      var regex = /^[0-9.,]+$/;
      var isValueRegular = regex.test(value);
      var handledValue = void 0;
      var lastValidValue = this.state.oldValue;
      if (!isValueRegular && value !== '') {
        // input contains invalid value
        // e.g. 1,00AAbasdasd.asdasd123123
        // - reject it and show last valid value
        handledValue = lastValidValue ? lastValidValue : '0.000000';
        position = position - 1;
      } else if (!this._isNumeric(value)) {
        // input contains comma separated number
        // e.g. 1,000,000.123456
        // - make sure commas and caret are at correct position
        var splitedValue = value.split('.');
        if (splitedValue.length === 3) {
          // input value contains more than one dot
          var splitedOldValue = lastValidValue.split('.');
          var beforeDot = splitedValue[0] + splitedValue[1];
          if (splitedOldValue[0].length < beforeDot.length) {
            // dot is in decimal part
            position -= 1;
            handledValue = beforeDot + '.' + splitedValue[2];
            beforeDot = beforeDot.replace(/,/g, '');
            // prevent replace dot if length before dot is greater then max before dot length
            if (beforeDot.length > this.props.maxBeforeDot) {
              handledValue = lastValidValue;
            }
          } else {
            handledValue = splitedValue[0] + '.' + splitedValue[1] + splitedValue[2];
            // Second dot was entered after current one -> stay in same position (swallow dot)
            if (position > beforeDot.length + 1) {
              position -= 1;
            }
          }
        } else if (splitedValue.length === 2 && splitedValue[0] === '' && splitedValue[1] === '') {
          // special case when dot is inserted in an empty input
          // - return 0.|00000
          handledValue = '0.000000';
          position = 2; // position caret after the dot
        } else if (value !== '') {
          // special case when user selects part of an input value and hits ',' key
          // - reject it and show last valid value
          handledValue = lastValidValue;
        }
      }

      var lastInsertedCharacter = value.substring(position - 1, position);
      if (lastInsertedCharacter === ',') {
        // prevent move caret position on hit ','
        position = position - 1;
      }

      return !this._isNumeric(value) ? { value: handledValue, position: position } : { value: value, position: position };
    }
  }, {
    key: '_parseToParts',
    value: function _parseToParts(data) {
      var value = data.value;
      var position = data.position;

      // show placeholder on select all and delete/backspace key action
      if (!value) return;

      var beforeDot = void 0,
          afterDot = void 0;
      if (data.value.length > 1 && value.split('.').length < 2) {
        // handle numbers deletion from both integer and decimal parts at once
        beforeDot = value.substring(0, position) || '0';
        afterDot = value.substring(position, value.length);
      } else {
        // split float number to integer and decimal part - regular way
        var splitedValue = value.split('.');
        beforeDot = splitedValue[0] ? splitedValue[0] : '0';
        afterDot = splitedValue[1] ? splitedValue[1] : '000000';
      }

      // remove leading zero and update caret position
      if (value.charAt(0) === '0' && parseInt(beforeDot.replace(/,/g, '')) > 0) {
        beforeDot = parseInt(beforeDot.replace(/,/g, ''));
        if (position !== 2) {
          position = 0;
        } else {
          position = 1;
        }
      } else if (parseInt(beforeDot.replace(/,/g, '')) === 0) {
        beforeDot = parseInt(beforeDot.replace(/,/g, ''));
      }

      return { value: value, position: position, parts: { beforeDot: beforeDot, afterDot: afterDot } };
    }
  }, {
    key: '_enforceMaxLengths',
    value: function _enforceMaxLengths(data) {
      if (!data) return;

      var _props = this.props,
          maxBeforeDot = _props.maxBeforeDot,
          maxAfterDot = _props.maxAfterDot,
          minValue = _props.minValue,
          maxValue = _props.maxValue;

      var value = data.value;
      var position = data.position;
      var beforeDot = data.parts.beforeDot;
      var afterDot = data.parts.afterDot;

      // preventing numbers with more than maxBeforeDot units
      // - return first maxBeforeDot numbers (with comma separators)
      if (maxBeforeDot && beforeDot) {
        // max number of commas depending on max number of characters before dot
        var numberOfCommas = maxBeforeDot % 3 > 0 ? parseInt(maxBeforeDot / 3) : parseInt(maxBeforeDot / 3) - 1;
        var maxBeforeDotWithSeparator = maxBeforeDot + numberOfCommas;
        if (beforeDot.length > maxBeforeDotWithSeparator) {
          beforeDot = beforeDot.substring(0, maxBeforeDotWithSeparator);
        }
      }

      // remove commas from decimal part (e.g. 123,23,2.002000 -> dot after 2.character reproduce 12.3,23,2)
      afterDot = afterDot.replace(/,/g, '');
      // preventing numbers with more than maxAfterDot units - return first maxAfterDot numbers
      if (maxAfterDot && afterDot && afterDot.length > maxAfterDot) {
        afterDot = afterDot.substring(0, maxAfterDot);
      }

      // if decimal number has less than maxAfterDot numbers add trailing zeros
      var afterDotLength = afterDot ? afterDot.length : 0;
      if (maxAfterDot && afterDotLength < maxAfterDot) {
        var i = void 0;
        for (afterDotLength; afterDotLength < maxAfterDot; afterDotLength++) {
          afterDot = afterDot + '0';
        }
      }

      var result = beforeDot + '.' + afterDot;

      // check min and max value
      var resultWithoutSeparators = parseFloat(result.replace(/,/g, ''));
      if (maxValue && resultWithoutSeparators > maxValue || minValue && resultWithoutSeparators < minValue) {
        this.setState({ error: 'Please enter a valid amount' });
      } else if (this.state.error !== '') {
        this.setState({ error: null });
      }

      this.setState({ caretPosition: position });
      return result;
    }
  }, {
    key: '_separate',
    value: function _separate(value, position) {
      this.setState({ oldValue: value });
      if (value) {
        var splitedValue = value.split('.');
        var separatedValue = splitedValue[0].replace(/,/g, '').split('').reverse().join('').replace(/(\d{3}\B)/g, '$1,').split('').reverse().join('');
        var newSeparatorsCount = (separatedValue.match(/,/g) || []).length;
        this.setState({ separatorsCount: newSeparatorsCount });
        return separatedValue + '.' + splitedValue[1];
      }
    }
  }, {
    key: '_isNumeric',
    value: function _isNumeric(value) {
      var replacedValue = value.replace(/,/g, '');
      return !isNaN(parseFloat(replacedValue)) && isFinite(replacedValue);
    }
  }]);

  return NumericInput;
}(_FormField3.default), _class.SKIN_PARTS = {
  INPUT: _Input2.default.SKIN_PARTS.INPUT
}, _class.propTypes = Object.assign({}, _FormField3.default.propTypes, {
  error: _props2.StringOrElement,
  value: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  maxBeforeDot: _propTypes2.default.number, // max number of characters before dot
  maxAfterDot: _propTypes2.default.number, // max number of characters after dot
  maxValue: _propTypes2.default.number, // max allowed numeric value
  minValue: _propTypes2.default.number // min allowed numeric value
}), _class.defaultProps = {
  value: '',
  error: ''
}, _temp2);
exports.default = NumericInput;
//# sourceMappingURL=NumericInput.js.map