'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tooltipSkinFactory = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _props = require('../../../utils/props');

var _reactCssThemr = require('react-css-themr');

var _identifiers = require('../identifiers');

var _Bubble = require('../../../components/Bubble');

var _Bubble2 = _interopRequireDefault(_Bubble);

var _BubbleSkin = require('./BubbleSkin');

var _BubbleSkin2 = _interopRequireDefault(_BubbleSkin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * The raw skin for the Tooltip component.
 *
 * Since the skin uses raw sub-components by default, it exports this
 * factory method to make this configurable from the outside. This
 * is needed to provide components with a default skin (see one level up).
 *
 * @param BubbleSkin
 * @returns {Component}
 */

var tooltipSkinFactory = exports.tooltipSkinFactory = function tooltipSkinFactory(BubbleSkin) {
  return function (props) {
    return _react2.default.createElement(
      'span',
      _extends({}, (0, _props.pickDOMProps)(props), {
        className: (0, _classnames2.default)([props.className, props.theme.root])
      }),
      _react2.default.createElement(
        _Bubble2.default,
        {
          skin: _react2.default.createElement(BubbleSkin, null),
          isOpeningUpward: props.isOpeningUpward,
          className: (0, _classnames2.default)([props.theme.bubble, props.isAligningRight ? props.theme.alignRight : props.theme.alignLeft, props.isBounded ? null : props.theme.nowrap])
        },
        props.tip
      ),
      props.children
    );
  };
};

/**
 * Export the raw version of this component which does not include any styles.
 */
exports.default = (0, _reactCssThemr.themr)(_identifiers.TOOLTIP)(tooltipSkinFactory(_BubbleSkin2.default));
//# sourceMappingURL=TooltipSkin.js.map